/**
 * Copyright (C) 2001-2005 France Telecom R&D
 */
package org.objectweb.jorm.mapper.rdb.adapter;

import org.objectweb.jorm.mapper.rdb.adapter.api.RdbAdapterException;
import org.objectweb.jorm.mapper.rdb.adapter.api.RdbAdapter;
import org.objectweb.jorm.mapper.rdb.adapter.api.TypeAdapter;

import java.sql.Array;
import java.sql.ResultSet;
import java.util.Map;

/**
 * This class is a generic implementation of the java.sql.Array interface,
 * permiting to store array through JDBC.
 *
 * @author S.Chassande-Barrioz
 */
public class BasicArray implements Array {

    public static boolean isArray(int typeCode) {
    	return typeCode >= TypeAdapter.TYPECODE_ARRAY;
    }

    public static int getElementArrayTypeCode(int typeCode) {
    	return typeCode % TypeAdapter.TYPECODE_ARRAY;
    }
    
    private int typeCode;
    private Object value;
    private int baseType;
    private String baseTypeName;
    private String strValue;
    
    public BasicArray(Object _value, 
            int _typeCode, 
            RdbAdapter adapter,
            String _baseTypeName) throws RdbAdapterException {
        this.typeCode = _typeCode;
        this.value = _value;
        this.baseTypeName = _baseTypeName;
        int innerTypeCode = getElementArrayTypeCode(typeCode);
        baseType = adapter.getSqlTypeCode(innerTypeCode);
        strValue = adapter.getArrayToString(value,typeCode);
    }

    public String toString() {
        return strValue;
    }
    
    public int getBaseType() {
        return baseType;
    }
    public Object getArray() {
        return value;
    }
    public Object getArray(long index, int count) {
        return value;
    }
    public Object getArray(long index, int count, Map map) {
        return value;
    }
    public Object getArray(Map map) {
        return value;
    }
    public String getBaseTypeName() {
        return baseTypeName;
    }
    public ResultSet getResultSet() {
        return null;
    }
    public ResultSet getResultSet(long index, int count) {
        return null;
    }
    public ResultSet getResultSet(long index, int count, Map map) {
        return null;
    }
    public ResultSet getResultSet(Map map) {
        return null;
    }
}
